;***************************************************************************************************
;        This DLL exports four procedures that write Operating System           
;        Version data to a text file in the 'Information' directory.       
;        Current Date:    February 2, 2011    
;***************************************************************************************************
;                Common assembler directives     
;***************************************************************************************************
.486    ; minimum processor needed for 32 bit. 80486 processor and higher.         
.model flat, stdcall       ;  selects the programming model      
option casemap:none        ;  case sensitive    
;***************************************************************************************************
;    The following list of includes is standard.    
;***************************************************************************************************
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
;***************************************************************************************************
;  The following structure is slightly altered from the one currently in windows.inc     
;  This makes it convenient to change the code as desired and re-compile.    
;***************************************************************************************************
 
OSVERSIONINFOEXsdk STRUCT
  dwOSVersionInfoSize DWORD ?
  dwMajorVersion  DWORD ?
  dwMinorVersion  DWORD ?
  dwBuildNumber   DWORD ?
  dwPlatformId    DWORD ?
  szCSDVersion    BYTE  128  dup (?)
  wServicePackMajor WORD ?
  wServicePackMinor WORD ?
  wSuiteMask WORD ?    
  wProductType BYTE ?
  wReserved BYTE ?
OSVERSIONINFOEXsdk ENDS

;***************************************************************************************************

.data    
;***************************************************************************************************
CurrentDirectory BYTE 256 DUP(0)    ;  Path for Current Directory    
VersionDataDir BYTE  256 DUP(0)    ;  Path to use in CreateDirectory    
VersionInfoFile BYTE 256 DUP(0)    ;  Path to the Information File    
lpDataDir LPTSTR 0    ;  Pointer to String with directory path    
lpVerInfo LPTSTR 0    ;  Pointer to String for Information file    
CurUserName BYTE 64 DUP(0)    ;  Current User Name     
lpCurUser LPTSTR 0    ;    
LoclComptrNam BYTE 64 DUP(0)    ;  Local Computer Name    
lpLoclComptr LPTSTR 0    ;  
DsplyUserName BYTE 128 DUP (0)    
DsplyComptrName BYTE 128 DUP (0)    
AccountNameSid BYTE 128 DUP(0)    ;  Account Name returned from LookupAccountSid    
lpAccntName LPTSTR 0    ;  Pointer to string with Account Name    
DsplyAccntName BYTE 256 DUP (0)    
DomainNameSid BYTE 128 DUP(0)    ;  Domain Name returned from LookupAccountSid  
lpDomainName LPTSTR 0    ;  Pointer to string with Domain Name
DsplyDomainNm BYTE 256 DUP (0)    
UserSIDStrng BYTE 128 DUP(0)    ;  String that contains the User's SID    
lpUserSid LPTSTR 0    ;  Pointer to string with User's SID
DsplyUserSIDStr BYTE 256 DUP (0)    
szNameDirectory BYTE "\\Information", 0    
szNameInfoFile BYTE "\\Operating System Info.txt", 0    
LoadLibName BYTE 128 DUP(0)    ;  Memory buffer for name and path of DLL.    
ProcAddrName BYTE 64 DUP(0)    ;  Memory buffer for name of function used in GetProcAddress.    
CurWindwsDir BYTE 128 DUP(0)    ;  Memory buffer for path of Windows directory.    
szAdvApiLib BYTE "\\advapi32.dll", 0    
szKernel32Lib BYTE "\\kernel32.dll", 0    
hAdvApiLib HMODULE 0    ;  HMODULE returned from LoadLibrary (advapi32.dll).    
hKrnl32Lib HMODULE 0    ;  HMODULE returned from LoadLibrary (kernel32.dll).   
szErrLoadAdvLib BYTE "ERROR: LoadLibrary FAILED for advapi32.dll.", 0Dh, 0Ah, 0
szErrLodKrnlLib BYTE "ERROR: LoadLibrary FAILED for kernel32.dll.", 0Dh, 0Ah, 0
szErrGetProcAddr BYTE "ERROR: GetProcAddress FAILED for ConvertSidToStringSid.", 0Dh, 0Ah, 0
szErrPrcsrFeaturPrsnt BYTE "ERROR: GetProcAddress FAILED for IsProcessorFeaturePresent.", 0Dh, 0Ah, 0
szFnctNotSuportd BYTE "The IsProcessorFeaturePresent function is NOT supported on Windows 95, 98, or ME.", 0Dh, 0Ah, 0    
szErrGetProdctInf BYTE "ERROR: GetProcAddress FAILED for GetProductInfo.", 0Dh, 0Ah, 0
szErRtnGtPrdtInfo BYTE "ERROR: GetProductInfo FAILED. Return value zero.", 0Dh, 0Ah, 0
;    The spelling and case of a function name in the string must be identical to  
;    that in the EXPORTS statement of the source DLL's module-definition (.Def) file.     
;    Either:    "ConvertSidToStringSidA",    or,    "ConvertSidToStringSidW"    succeeds.    
szCnvSidToStr BYTE "ConvertSidToStringSidA", 0    ;  But,    "ConvertSidToStringSid" FAILS.        
szProcsrFeturPresnt BYTE "IsProcessorFeaturePresent", 0    ;  NOT supported on Windows 95, 98, or ME.    
szGetProdctInfo BYTE "GetProductInfo", 0    ;     
dwGetProductInfo DWORD 0    ;    This is the address of GetProductInfo returned from GetProcAddress.    
CurDateTime SYSTEMTIME <0,0,0,0,0,0,0,0>
hCurThread HANDLE 0    ;  Pseudo-handle to current Thread, calling CloseHandle has no effect
hThrdTokn HANDLE 0    ;  Must be closed with CloseHandle.    
hCurProcess HANDLE 0    ;  Pseudo-handle to current Process, calling CloseHandle has no effect
hProcssTokn HANDLE 0    ;  Handle to Access Token, returned from OpenProcessToken.    
hProcssHeap HANDLE 0    ;  Returned from GetProcessHeap.    
lpToknUserInfo LPVOID 0    ;  Pointer to memory allocated with HeapAlloc for Token User Info.    
lpTokGroupsInf LPVOID 0    ;  Pointer to memory allocated with HeapAlloc for Token Groups Info.
lpTknPrvlgsInfo LPVOID 0    ;  Pointer to memory allocated with HeapAlloc for Token Privileges Info.
AuthrtySid SID_IDENTIFIER_AUTHORITY <SECURITY_NT_AUTHORITY>    ;  Used to initialize the Administrator Group SID.    
dwpUserSID DWORD 0    ;  This is the pointer to the User SID returned from GetTokenInformation.    
dwpAdminGrpSid DWORD 0    ;  This is the pointer to the NT_AUTHORITY SID created to check Adminstrative privileges.    
TknErrNumbr BYTE 16 dup (0)    ;  Display error from GetLastError.    
szGetLstErr BYTE "GetLastError returned: ", 0    
szNumGroups BYTE "Number of Groups is: ", 0    
DsplyErrNumbr BYTE 128 DUP(0)    ;    
LocalSystmInfo SYSTEM_INFO <0,0,0,0,0,0,0,0,0,0,0>
LoclOperatSystem OSVERSIONINFOEXsdk <>  
Win98VerInfo OSVERSIONINFO <>    ;  If GetVersionEx initially fails, this is substituted.    
dwRtrnProdctTyp DWORD 0    ;    Returned from GetProductInfo (if operating system is Vista or greater).
DsplBuldNumbr BYTE 128 DUP(0)    ;  Buffer to hold Build Number String.    
szWinBldNum BYTE "The Build Number of the Operating System is: ", 0    
OSBuildNum BYTE 32 DUP (0)    ;  Buffer to hold value converted with DwtoA 
DsplServcPacks BYTE 128 DUP(0)    ;  Buffer to hold Service Packs installed.    
szInstlSrvcPck BYTE "The Latest Service Pack installed is: ", 0    
ServicePack BYTE 32 DUP (0)    ;  Buffer to hold values converted with DwtoA 
szMajSrvcPk BYTE "Major: ", 0    
szMinrSrvPk BYTE ", Minor: ", 0    
szNoServicePack BYTE "There are NO currently installed Service Packs.", 0Dh, 0Ah, 0
CurMonthDay BYTE 64 DUP(0)    ;  Month Day Year string    
TimeDate BYTE 16 DUP(0)    ;    Buffer for day of month from DwtoA
TimeYear BYTE 16 DUP(0)    ;    Buffer for current year from DwtoA    
szRowDelimit BYTE "--------------------------------------------------------------------------------", 0Dh, 0Ah, 0
szTodayDate BYTE "Today's Date is: ", 0    
szCurUserNm BYTE "Current User Name is: ", 0    
szComptrName BYTE "Local Computer Name is: ", 0    
szSidAccntNam BYTE "Local Account Name is: ", 0    
szDomanNam BYTE "Domain Name is: ", 0    
szUserSid BYTE "The User's SID is: ", 0    
szMonJan BYTE "January ", 0    
szMonFeb BYTE "February ", 0    
szMonMarch BYTE "March ", 0    
szMonApr BYTE "April ", 0    
szMonMay BYTE "May ", 0    
szMonJune BYTE "June ", 0    
szMonJuly BYTE "July ", 0    
szMonAug BYTE "August ", 0    
szMonSept BYTE "September ", 0    
szMonOct BYTE "October ", 0    
szMonNov BYTE "November ", 0    
szMonDec BYTE "December ", 0    
szEndLine BYTE 0Dh, 0Ah, 0   
szCommaSpace BYTE 2Ch, 20h, 0
szTwoSpaces BYTE 20h, 20h, 0

szNotValidSid BYTE "IsValidSID FAILED.", 0Dh, 0Ah, 0 
szErrTknAcsDend BYTE "GetThreadToken returned ERROR_ACCESS_DENIED. Function aborted.", 0Dh, 0Ah, 0  
szErrGetTknInfo BYTE "GetTokenInformation FAILED for Process Token. Function aborted.", 0Dh, 0Ah, 0  
szErrUnknwnTkn BYTE "Unknown Error occurred in GetTokenInformation.", 0Dh, 0Ah, 0 
szErrHeapAlloc BYTE "HeapAlloc FAILED for Process Token.", 0Dh, 0Ah, 0
szErrOpnProcsTkn BYTE "OpenProcessToken FAILED. Function aborted.", 0Dh, 0Ah, 0  
szErrLkupAccntSid BYTE "LookupAccountSid FAILED.", 0Dh, 0Ah, 0    
szErrConvrtSidStr BYTE "ConvertSidToStringSid FAILED.", 0Dh, 0Ah, 0   
szErrSidZeroLen BYTE "ERROR: The SID String has zero length.", 0Dh, 0Ah, 0      
szErrGetVersion BYTE "GetVersionEx FAILED. ChckOperSysVersion function aborted.", 0Dh, 0Ah, 0      
szErrInitAdminSid BYTE "AllocateAndInitializeSid FAILED. Check for Administravive privileges aborted.", 0Dh, 0Ah, 0      
szFileHeadrInfo BYTE "Preliminary Operating System Information:",  0Dh, 0Ah, 0 
hInfoFile HANDLE 0    ;  Handle returned from CreateFile    
dwCurFilePtr DWORD 0    ;  Current File Pointer    
szChckAdmin BYTE "Check Administrative Privileges begin loop.",  0Dh, 0Ah, 0    
szAdminPrvlgs  BYTE "The current user has Administrative Privileges enabled.",  0Dh, 0Ah, 0 
szNOAdminPrvlg BYTE "The current user does NOT have Administrative Privileges.",  0Dh, 0Ah, 0 
szEnumCurPrvlgs BYTE "Privilege enumeration for the current user:",  0Dh, 0Ah, 0 
DsplyNumPrvlgs BYTE 64 DUP(0)    
NmbrPrvlgsStr BYTE 16 DUP (0)
szNumbrPrivlgs BYTE "The number of privileges is: ", 0 
LookupPrvlgName BYTE 64 DUP (0)    ;    Buffer that receives string that represents the privilege's name.    
dwSizPrvlgNam DWORD 0    ;    Length of Privilege Name not including the terminating null character.    
lpPrvlgName LPTSTR 0    ;    Pointer to buffer that receives string that represents the privilege's name.    
szErrLookPrvlgNam  BYTE "ERROR: LookupPrivilegeName FAILED.", 0Dh, 0Ah, 0 
DsplyPrvlgEnabl BYTE 128 DUP (0)    ;   
szPrvlgEnabld BYTE " is Enabled.", 0
szPrvlgDisabld BYTE " is Disabled.", 0    
szPrvlgDefltEnbld BYTE " is Enabled by Default.", 0
szPrvlgUsedAccess BYTE " is Used for Access.", 0    
CntNumPrivlgs DWORD 0    

;    The following is a list of the 35 currently available Privilege Names to compare with LookupPrivilegeName.    
;    The first seven Privileges are considered super-Priveleges by author of "Windows Internals".    

szPrvlgTrstdCmpBs BYTE "SeTcbPrivilege", 0    
szPrvlgSecrty BYTE "SeSecurityPrivilege", 0    
szPrvlgTakeOwnrshp BYTE "SeTakeOwnershipPrivilege", 0    
szPrvlgCretTokn BYTE "SeCreateTokenPrivilege", 0    
szPrvlgAsgnPriTokn BYTE "SeAssignPrimaryTokenPrivilege", 0    
szPrvlgBackup BYTE "SeBackupPrivilege", 0    
szPrvlgRestore BYTE "SeRestorePrivilege", 0    
szPrvlgDebug BYTE "SeDebugPrivilege", 0    
szPrvlgLoadDrivr BYTE "SeLoadDriverPrivilege", 0    
szPrvlgGenAudit BYTE "SeAuditPrivilege", 0
szPrvlgChngNotfy BYTE "SeChangeNotifyPrivilege", 0    
szPrvlgMapGlblNmspc BYTE "SeCreateGlobalPrivilege", 0    
szPrvlgCrtPageFil BYTE "SeCreatePagefilePrivilege", 0    
szPrvlgCrtPrmntObj BYTE "SeCreatePermanentPrivilege", 0    
szPrvlgCrtSymblcLnk BYTE "SeCreateSymbolicLinkPrivilege", 0    
szPrvlgTrstdDelgtn BYTE "SeEnableDelegationPrivilege", 0    
szPrvlgImprsntClnt BYTE "SeImpersonatePrivilege", 0    
szPrvlgIncBaseProrty BYTE "SeIncreaseBasePriorityPrivilege", 0    
szPrvlgIncQuotPrcs BYTE "SeIncreaseQuotaPrivilege", 0    
szPrvlgIncWrkngSet BYTE "SeIncreaseWorkingSetPrivilege", 0    
szPrvlgLockMemPags BYTE "SeLockMemoryPrivilege", 0    
szPrvlgCrtMachAcnt BYTE "SeMachineAccountPrivilege", 0    
szPrvlgVolMangmnt BYTE "SeManageVolumePrivilege", 0    
szPrvlgProflPrcs BYTE "SeProfileSingleProcessPrivilege", 0    
szPrvlgModIntgrLvl BYTE "SeRelabelPrivilege", 0    
szPrvlgRemtShutDwn BYTE "SeRemoteShutdownPrivilege", 0    
szPrvlgLoclShutDwn BYTE "SeShutdownPrivilege", 0    
szPrvlgDmnCntrlDirSync BYTE "SeSyncAgentPrivilege", 0    
szPrvlgModNVolRam BYTE "SeSystemEnvironmentPrivilege", 0    
szPrvlgSysProflInfo BYTE "SeSystemProfilePrivilege", 0    
szPrvlgModSysTim BYTE "SeSystemtimePrivilege", 0    
szPrvlgAdjTimZon BYTE "SeTimeZonePrivilege", 0    
szPrvlgAcsCredMngr BYTE "SeTrustedCredManAccessPrivilege", 0    
szPrvlgUndckLptop BYTE "SeUndockPrivilege", 0    
szPrvlgInptTrmnlDvc BYTE "SeUnsolicitedInputPrivilege", 0    

;    Define the Product Types for the return value from GetProductInfo (Vista and greater).    51 total    
;    Many of these values are already defined in windows.inc    I have commented them out.    

;    PRODUCT_UNDEFINED equ 00000000h
;    PRODUCT_UNLICENSED equ ABCDABCDh
;    PRODUCT_BUSINESS equ 00000006h
;    PRODUCT_BUSINESS_N equ 00000010h
;    PRODUCT_CLUSTER_SERVER equ 00000012h
;    PRODUCT_DATACENTER_SERVER equ 00000008h
;    PRODUCT_DATACENTER_SERVER_CORE equ 0000000Ch
PRODUCT_DATACENTER_SERVER_CORE_V equ 00000027h
PRODUCT_DATACENTER_SERVER_V equ 00000025h
;    PRODUCT_ENTERPRISE equ 00000004h
PRODUCT_ENTERPRISE_E equ 00000046h    ;    Not Supported
PRODUCT_ENTERPRISE_N equ 0000001Bh
;    PRODUCT_ENTERPRISE_SERVER equ 0000000Ah
;    PRODUCT_ENTERPRISE_SERVER_CORE equ 0000000Eh
PRODUCT_ENTERPRISE_SERVER_CORE_V equ 00000029h
;    PRODUCT_ENTERPRISE_SERVER_IA64 equ 0000000Fh
PRODUCT_ENTERPRISE_SERVER_V equ 00000026h
;    PRODUCT_HOME_BASIC equ 00000002h
PRODUCT_HOME_BASIC_E equ 00000043h    ;    Not Supported
;    PRODUCT_HOME_BASIC_N equ 00000005h
;    PRODUCT_HOME_PREMIUM equ 00000003h
PRODUCT_HOME_PREMIUM_E equ 00000044h    ;    Not Supported
PRODUCT_HOME_PREMIUM_N equ 0000001Ah
PRODUCT_HYPERV equ 0000002Ah
PRODUCT_MEDIUMBUSINESS_SERVER_MANAGEMENT equ 0000001Eh
PRODUCT_MEDIUMBUSINESS_SERVER_MESSAGING equ 00000020h
PRODUCT_MEDIUMBUSINESS_SERVER_SECURITY equ 0000001Fh
PRODUCT_PROFESSIONAL equ 00000030h
PRODUCT_PROFESSIONAL_E equ 00000045h    ;    Not Supported
PRODUCT_PROFESSIONAL_N equ 00000031h 
;    PRODUCT_SERVER_FOR_SMALLBUSINESS equ 00000018h
PRODUCT_SERVER_FOR_SMALLBUSINESS_V equ 00000023h
PRODUCT_SERVER_FOUNDATION equ 00000021h
;    PRODUCT_SMALLBUSINESS_SERVER equ 00000009h
;    PRODUCT_SMALLBUSINESS_SERVER_PREMIUM equ 00000019h
PRODUCT_SOLUTION_EMBEDDEDSERVER equ 00000038h 
;    PRODUCT_STANDARD_SERVER equ 00000007h
;    PRODUCT_STANDARD_SERVER_CORE equ 0000000Dh
PRODUCT_STANDARD_SERVER_CORE_V equ 00000028h
PRODUCT_STANDARD_SERVER_V equ 00000024h
;    PRODUCT_STARTER equ 0000000Bh
PRODUCT_STARTER_E equ 00000042h    ;    Not Supported
PRODUCT_STARTER_N equ 0000002Fh
;    PRODUCT_STORAGE_ENTERPRISE_SERVER equ 00000017h
;    PRODUCT_STORAGE_EXPRESS_SERVER equ 00000014h
;    PRODUCT_STORAGE_STANDARD_SERVER equ 00000015h
;    PRODUCT_STORAGE_WORKGROUP_SERVER equ 00000016h
;    PRODUCT_ULTIMATE equ 00000001h
PRODUCT_ULTIMATE_E equ 00000047h    ;    Not Supported
PRODUCT_ULTIMATE_N equ 0000001Ch
;    PRODUCT_WEB_SERVER equ 00000011h 
PRODUCT_WEB_SERVER_CORE equ 0000001Dh

szCpuidInstrctn BYTE "The CPUID instruction is available in the instruction set of the processor.", 0Dh, 0Ah, 0 
szEarlyIntelPrcsr BYTE "The processor is early Intel 486 or older, and has NO CPUID instruction.", 0Dh, 0Ah, 0 
szUnknwnPrcssr BYTE "GetSystemInfo returned PROCESSOR_ARCHITECTURE_UNKNOWN", 0Dh, 0Ah, 0 
szProcssr32Bit BYTE "The Computer's Processor Architecture is INTEL 32-Bit.",  0Dh, 0Ah, 0 
szPrcsr64BitWnd BYTE "The Computer's Processor Architecture is INTEL 64-Bit.",  0Dh, 0Ah, 0 
szPrcsr64BitAMD BYTE "The Computer's Processor Architecture is AMD 64-Bit.",  0Dh, 0Ah, 0 
szProcr64BtWnds64 BYTE "The Computer's Processor Architecture is INTEL 64-Bit on Windows 64.", 0Dh, 0Ah, 0 
szRDTSCAvailable BYTE "Processor Feature: The Read Time-Stamp Counter (RDTSC) Instruction is available.", 0Dh, 0Ah, 0 
szRDTSCNotAvalbl BYTE "The RDTSC Instruction is NOT available on computer processor.", 0Dh, 0Ah, 0     

;  The MultiMedia Extensions (MMX) instruction set is available on Intel Pentium II's and better processors. 
;  The Pentium and Pentium Pro series do not have the MMX capabilities. Streaming SIMD (SSE) Extentions    
;  are available only on Intel Pentium III's and better processors. Earlier processors do NOT have this capability.    
;  Data Execution Prevention (DEP) is a processor hardware protection that prevents ececution of instructions    
;  on a memory page  marked "no execute". It is available on Intel Pentium 4, Xeon, and Intel IA-64 processors.    

szMMXInstrctnAvailbl BYTE "Processor Feature: The Multimedia Extensions (MMX) instruction set is available.", 0Dh, 0Ah, 0 
szMMXInstrNotAvalbl BYTE "The MMX instruction set is NOT available on computer processor.", 0Dh, 0Ah, 0 
szSSEInstrctnAvailbl BYTE "Processor Feature: Streaming SIMD Extensions (SSE) instruction set is available.", 0Dh, 0Ah, 0 
szSSEInstnNotAvalbl BYTE "(SSE) Streaming Single Instruction Multiple Data (SIMD) instruction set is NOT available on computer processor.", 0Dh, 0Ah, 0 
szSSE2AvailbInstns BYTE "Processor Feature: Streaming SIMD Extensions 2 (SSE2) instruction set is available.", 0Dh, 0Ah, 0 
szNOSSE2InstrnSet BYTE "(SSE2) Streaming SIMD Extensions 2 instruction set is NOT available on computer processor.", 0Dh, 0Ah, 0 
szSSE3InsrtnSetSprt BYTE "Processor Feature: Streaming SIMD Extensions 3 (SSE3)  instruction set is available.", 0Dh, 0Ah, 0 
szNoSSE3InsrtnSet BYTE "(SSE3) Streaming SIMD Extensions 3 instruction set is NOT available on computer processor.", 0Dh, 0Ah, 0 
szPhyslAddrExtSup BYTE   "Physical addresses greater than 32-bit are supported on processor (all x64 processors support PAE).", 0Dh, 0Ah, 0 
szNOPAESupprt BYTE "The processor does NOT support (PAE) Physical addresses greater than 32-bit.", 0Dh, 0Ah, 0 
szDEPProtctAvabl BYTE "Processor Feature: Data Execution Prevention (DEP) Page execute prevention is available.", 0Dh, 0Ah, 0 
szDEPNotAvailable BYTE "Data Execution Prevention (DEP) is NOT available on computer processor.", 0Dh, 0Ah, 0    

szOSWinOld95 BYTE "The Installed Operating System is: Windows 95.", 0Dh, 0Ah, 0    ;  integrated a 32-bit TCP/IP stack for built-in Internet support.  
szOldOSWin98 BYTE "The Installed Operating System is: Windows 98.", 0Dh, 0Ah, 0    
szOSWinMEOld BYTE "The Installed Operating System is: Windows Millennium Edition .", 0Dh, 0Ah, 0    ;  Released in 2000, based on Windows 95 codebase.  
szWinNT4OldOS BYTE "The Installed Operating System is: Windows NT Workstation 4.0", 0Dh, 0Ah, 0    ;  Upgrade to the Microsoft business desktop operating system.   
szOldWinNT3OS BYTE "The Installed Operating System is: Windows NT Workstation 3.5", 0Dh, 0Ah, 0    ;  Released in 1994,    
szUnknwnOprSys BYTE "Unknown Windows Operating System; unable to determine operating system. ", 0Dh, 0Ah, 0   
szWinNT4WrkStatn BYTE "The Installed Operating System is: Windows NT 4.0 Workstation.", 0Dh, 0Ah, 0 
szWin2KUnknClnt BYTE "The Installed Operating System is an unknown Client Version of Windows 2000.", 0Dh, 0Ah, 0    ;  This represents an error; but is Windows 2000.   
szWin2KProfessnl BYTE "The Installed Operating System is: Windows 2000 Professional.", 0Dh, 0Ah, 0    ;  Client built on top of the proven Windows NT Workstation 4.0 code base.  
szWin2KDtCntrSrv BYTE "The Installed Operating System is: Windows 2000 Data Center Server.", 0Dh, 0Ah, 0 
szWin2KAdvdSrvr BYTE "The Installed Operating System is: Windows 2000 Advanced Server.", 0Dh, 0Ah, 0 
szWin2KSrvr BYTE "The Installed Operating System is: Windows 2000 Server.", 0Dh, 0Ah, 0 
szWinXPHomEd BYTE "The Installed Operating System is: Windows XP Home Edition. ", 0Dh, 0Ah, 0 
szWinXPMdiaCntr BYTE "The Installed Operating System is: Windows XP Media Center Edition. ", 0Dh, 0Ah, 0 
szWinXPProfessnl BYTE "The Installed Operating System is: Windows XP Professional.", 0Dh, 0Ah, 0    ;  Released in 2001 
szWinXPPro64BitEd BYTE "The Installed Operating System is: Windows XP Professional x64 Edition.", 0Dh, 0Ah, 0    ;       
;   Windows Server 2003 is the first server operating system to feature built-in Microsoft .NET functionality.      
szWinServr2003 BYTE "The Installed Operating System is: Windows Server 2003, Standard Edition.", 0Dh, 0Ah, 0   
szWinHomeSrvr BYTE "The Installed Operating System is: Windows Home Server 2003.", 0Dh, 0Ah, 0   
szWin2003DatCntr BYTE "The Installed Operating System is: Windows Server 2003, Datacenter Edition.", 0Dh, 0Ah, 0   
szWin2003Entrprs BYTE "The Installed Operating System is: Windows Server 2003, Enterprise Edition.", 0Dh, 0Ah, 0   
szWin2003WebSrvr BYTE "The Installed Operating System is: Windows Server 2003, Web Edition.", 0Dh, 0Ah, 0   
szWin2003ServrR2 BYTE " The Installed Operating System is: Windows Server 2003 R2.", 0Dh, 0Ah, 0   
szWinVistaWrkStn BYTE "The Installed Operating System is: Windows Vista, ", 0    ;    Released 2006, User Account Control added.     
szVistaHomeBasic BYTE "The Installed Operating System is: Windows Vista Home Premium or Home Basic.", 0Dh, 0Ah, 0   
szWinSrvr2008Stnd BYTE "The Installed Operating System is: Windows Server 2008, ", 0   
szWinSevnWrkStn BYTE "The Installed Operating System is: Windows Seven, ", 0    ;    Released 2009.    
szWinSevnSrvrR2 BYTE "The Installed Operating System is: Windows Server 2008 R2, ", 0   
szUltimatEdtn BYTE "Ultimate Edition.", 0    
szVstaProfesnl BYTE "Professional.", 0     
szHomePremium BYTE "Home Premium Edition.", 0    
szHoneBasic BYTE "Home Basic Edition.", 0    
szEntrpriseEdtn BYTE " Enterprise Edition.", 0    
szEntrprseSrvrEdtn BYTE "Enterprise Server Edition (Full Installation).", 0    
szBusinesEdtn BYTE "Business Edition.", 0    
szStartrEditn BYTE  "Starter Edition.", 0    
szClustrSrvrEdtn BYTE "Cluster Server Edition.", 0    
szDataCntrEdtn BYTE "Datacenter Server Edition (Full Installation),", 0    
szDatCntrCoreEdtn BYTE "Datacenter Edition (Core Installation).", 0     
szEntrprsCoreEdtn BYTE "Enterprise Edition (Core Installation).", 0     
szEntrprsItaniumEdtn BYTE "Enterprise Server Edition for Itanium-based Systems.", 0    
szSmalBusinsSrvr BYTE "Small Business Server.", 0    
szSmalBusnsSrvrPrem BYTE "Small Business Server Premium Edition.", 0    
szStandrdEdtn BYTE "Standard Server Edition (Full Installation).", 0    
szStandrdCoreEdtn BYTE "Standard Edition (Core Installation).", 0     
szWebSrvrEdtn BYTE "Web Server Edition (Full Installation).", 0    

;    Prototype for the GetProductInfo function, introduced in Windows Vista.    
;    GetProductInfo PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

DsplVistaVerEdtn BYTE 128 DUP (0)    ;    Buffer to hold string that describes Vista edition.    
DsplWinSevnEdtn BYTE 128 DUP (0)    ;    Buffer to hold string that describes Windows Seven edition.    

VER_SUITE_WH_SERVER equ 00008000h    ;  Not defined in windows.inc    
;    Undefined privilege values from Windows XP, WinNT.h    
SE_UNDOCK_NAME equ ("SeUndockPrivilege")
SE_SYNC_AGENT_NAME equ ("SeSyncAgentPrivilege")
SE_ENABLE_DELEGATION_NAME equ ("SeEnableDelegationPrivilege")
SE_MANAGE_VOLUME_NAME equ ("SeManageVolumePrivilege")
;    Undefined privilege values from current Windows version.    
SE_TRUSTED_CREDMAN_ACCESS_NAME equ ("SeTrustedCredManAccessPrivilege")
SE_TIME_ZONE_NAME equ ("SeTimeZonePrivilege")
SE_RELABEL_NAME equ ("SeRelabelPrivilege")
SE_INC_WORKING_SET_NAME equ ("SeIncreaseWorkingSetPrivilege")
SE_IMPERSONATE_NAME equ ("SeImpersonatePrivilege")
SE_CREATE_SYMBOLIC_LINK_NAME equ ("SeCreateSymbolicLinkPrivilege")
SE_CREATE_GLOBAL_NAME equ ("SeCreateGlobalPrivilege")

;***************************************************************************************************
.code
;***************************************************************************************************
;    Note to programmers: If you are planning a custom implementation of these assembly    
;    language routines, there are four PUBLIC exported routines in total (not counting, DwtoA ).
;    They are designed to be used in sequence, but can be used separately. Important:    
;    CrtDataDirFile must ALWAYS be called first. It creates the directory and then invokes    
;    CreateFile (with CREATE_NEW attribute) and closes the File handle at the end of the
;    routine. Each of the other routines calls CreateFile again and ends with CloseHandle.    
;    So, they can be used individually, or, several can be used, or all four can be used,     
;    The last routine, ChckOperSysVersion, may need information obtained from the     
;    ChckProcessrCapabilts routine (for 64-bit processors and Operating Systems),    
;    and if the data isn't available, ChckOperSysVersion will invoke GetSystemInfo. If    
;    you call LoadLibrary and GetProcAddress to dynamically load the DLL, do NOT call   
;    FreeLibrary until you are completely done with these functions, because if the DLL  
;    is unloaded and then reloaded with LoadLibrary, all the stored data are re-initialized     
;    and the path memory to the Information file will be zeroed out, all calls to Create    
;    File at the beginning of each procedure will fail (and all subsequent WriteFile calls). 
;***************************************************************************************************
;  The DwtoA procedure is from the masm32 Lib, and is used only internally.        
;***************************************************************************************************

DwtoA PROC dwValue:DWORD, lpBuffer:DWORD

;***************************************************************************************************
;  Procedure converts DWORD to ascii string.    
;  dwValue is value to be converted
;  lpBuffer is the address of the receiving buffer
;  EXAMPLE:
;  invoke dwtoa,edx,ADDR buffer
;  Uses: eax, ecx, edx.
;  I have modified this slightly, because it reads unsigned
;  values that were originally WORD sized values, zero    
;  extended into a DWORD sized register for convenience.    
;***************************************************************************************************
    push ebx
    push esi
    push edi
    mov eax, dwValue
    mov edi, [lpBuffer]
    test eax,eax
    jnz pos
  zero:
    mov word ptr [edi],30h
    jmp dtaexit
  pos:
    mov ecx, 3435973837
    mov esi, edi
    .WHILE (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      add edi, 1
    .ENDW
    mov byte ptr [edi], 0       ; terminate the string
; We now have all the digits, but in reverse order.
    .WHILE (esi < edi)
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .ENDW
  dtaexit:
    pop edi
    pop esi
    pop ebx
    RET  
DwtoA ENDP

;***************************************************************************************************

CrtDataDirFile PROC USES eax ebx ecx        
LOCAL dwLenWrt:DWORD    
LOCAL dwLenNum:DWORD    

;  This procedure just creates a directory and Text File for Info.    
;  If the GetCurrentDirectory function fails, the return value is zero.     
    invoke GetCurrentDirectory, 256, ADDR CurrentDirectory    
    .IF eax==0
     RET
    .ENDIF    
;  If lstrcpy fails, the return value is NULL    
    invoke lstrcpy, ADDR VersionDataDir, ADDR CurrentDirectory        
    .IF eax==0
     RET
    .ENDIF    
;  If lstrcat fails, the return value is NULL    
    invoke lstrcat, ADDR VersionDataDir, ADDR szNameDirectory        
    .IF eax==0
     RET
    .ENDIF    
    MOV eax, OFFSET VersionDataDir    
    MOV lpDataDir, eax    
;  If CreateDirectory fails, the return value is zero. If the directory already    
;  exists, CreateDirectory fails, but, calling GetLastError returns 183.        
    invoke CreateDirectory, lpDataDir, NULL
    .IF eax==0
     invoke GetLastError
     CMP eax, 183
     JZ DirExists    
     RET    
    .ENDIF  
    
DirExists:
    invoke lstrcpy, ADDR VersionInfoFile, ADDR VersionDataDir 
    invoke lstrcat, ADDR VersionInfoFile, ADDR szNameInfoFile
    MOV eax, OFFSET VersionInfoFile    
    MOV lpVerInfo, eax    
;  If CreateFile fails, the return value is INVALID_HANDLE_VALUE    
;  Combining GENERIC_READ and GENERIC_WRITE give a value of: C0000000h hex or 3221225472 decimal.    
    invoke CreateFile, lpVerInfo, 0C0000000h, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL    
    .IF eax==INVALID_HANDLE_VALUE
     RET    
    .ENDIF    
    MOV hInfoFile, eax    
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_BEGIN
    MOV dwCurFilePtr, eax    
    invoke lstrlen, ADDR szRowDelimit
    MOV dwLenWrt, eax
    invoke WriteFile, hInfoFile, ADDR szRowDelimit, dwLenWrt, ADDR dwLenNum, NULL
    
    invoke GetSystemTime, ADDR CurDateTime    

    invoke lstrcpy, ADDR CurMonthDay, ADDR szTodayDate    
    CMP CurDateTime.wMonth, 0
    JZ ErrSysTime    
    .IF CurDateTime.wMonth==1
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonJan 
    .ELSEIF CurDateTime.wMonth==2
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonFeb 
    .ELSEIF CurDateTime.wMonth==3
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonMarch    
    .ELSEIF CurDateTime.wMonth==4
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonApr 
    .ELSEIF CurDateTime.wMonth==5
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonMay 
    .ELSEIF CurDateTime.wMonth==6
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonJune 
    .ELSEIF CurDateTime.wMonth==7
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonJuly 
    .ELSEIF CurDateTime.wMonth==8
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonAug 
    .ELSEIF CurDateTime.wMonth==9
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonSept 
    .ELSEIF CurDateTime.wMonth==10
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonOct 
    .ELSEIF CurDateTime.wMonth==11
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonNov 
    .ELSEIF CurDateTime.wMonth==12
    invoke lstrcat, ADDR CurMonthDay, ADDR szMonDec
    .ELSE
    JMP ErrSysTime 
    .ENDIF      

    XOR ebx, ebx    
    XOR ecx, ecx    
    
;  The STRUCT, defined in Windows.inc, is composed of 8 fields, all of WORD size.    
;  SYSTEMTIME.wYear is the first field. SYSTEMTIME.wDay is the fourth field.    

    MOV eax, OFFSET CurDateTime.wYear    
    MOV bx, [eax]    
    MOVZX ecx, bx
    invoke DwtoA, ecx, ADDR TimeYear    

    XOR ebx, ebx    
    XOR ecx, ecx    

    MOV eax, OFFSET CurDateTime.wDay    
    MOV cx, [eax]    
    MOVZX ebx, cx
    invoke DwtoA, ebx, ADDR TimeDate    

    invoke lstrcat, ADDR CurMonthDay, ADDR TimeDate    
    invoke lstrcat, ADDR CurMonthDay, ADDR szCommaSpace    
    invoke lstrcat, ADDR CurMonthDay, ADDR TimeYear    
    invoke lstrcat, ADDR CurMonthDay, ADDR szEndLine    
    invoke lstrlen, ADDR CurMonthDay
    MOV dwLenWrt, eax    
    invoke WriteFile, hInfoFile, ADDR CurMonthDay, dwLenWrt, ADDR dwLenNum, NULL
    .IF eax==0
     RET    
    .ENDIF    
    invoke lstrlen, ADDR szFileHeadrInfo
    MOV dwLenWrt, eax    
    invoke WriteFile, hInfoFile, ADDR szFileHeadrInfo, dwLenWrt, ADDR dwLenNum, NULL
    .IF eax==0
    RET    
    .ENDIF    
    JMP DateGood    
    
ErrSysTime:    
    RET    

DateGood:
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax

    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    
    RET

CrtDataDirFile ENDP

;***************************************************************************************************

ChckUserSecurity PROC    
LOCAL dwUserName:DWORD
LOCAL dwComptrNam:DWORD
LOCAL dwLastError:DWORD
LOCAL dwSizToknUsr: DWORD
LOCAL dwToknGrpsSiz:DWORD
LOCAL dwToknPrvlgsSiz:DWORD
LOCAL dwAccntName:DWORD
LOCAL dwDomainNam:DWORD
LOCAL dwTypSecDescrp:DWORD
LOCAL dwlenDtWrt:DWORD
LOCAL dwlenNmWrt:DWORD
LOCAL lpWindwsDir:DWORD
LOCAL lpPathLoadDll:DWORD
LOCAL lpProcName:DWORD    
LOCAL dwTknGrps:DWORD
LOCAL dwTknPrvlgs:DWORD

;  This procedure checks basic user names, displays the current user's SID, demonstrates how    
;  to call LoadLibrary and GetProcAddress, and reads information from the access token. Also,    
;  this procedure checks to see if the current user has Administrator privileges. And, if so, the    
;  names of the privileges are printed out, and also, whether they are disabled or enabled.    

    MOV eax, OFFSET VersionInfoFile    
    MOV lpVerInfo, eax    
    invoke CreateFile, lpVerInfo, 0C0000000h, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL    
    .IF eax==INVALID_HANDLE_VALUE    ;  Check for CreateFile failure. The function fails if the file does not exist.     
     RET    
    .ENDIF    
    MOV hInfoFile, eax    
    invoke SetFilePointer, hInfoFile, dwCurFilePtr, NULL, FILE_BEGIN
    MOV dwCurFilePtr, eax    

    invoke lstrlen, ADDR szRowDelimit
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szRowDelimit, dwlenDtWrt, ADDR dwlenNmWrt, NULL

    MOV eax, 64
    MOV dwUserName, eax
    MOV eax, OFFSET CurUserName
    MOV lpCurUser, eax
    invoke GetUserName, lpCurUser, ADDR dwUserName
    invoke lstrcpy, ADDR DsplyUserName, ADDR szCurUserNm    
    invoke lstrcat, ADDR DsplyUserName, ADDR CurUserName   
    invoke lstrcat, ADDR DsplyUserName, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyUserName
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyUserName, dwlenDtWrt, ADDR dwlenNmWrt, NULL

    MOV eax, 64
    MOV dwComptrNam, eax
    MOV eax, OFFSET LoclComptrNam
    MOV lpLoclComptr, eax
    invoke GetComputerName, lpLoclComptr, ADDR dwComptrNam
    invoke lstrcpy, ADDR DsplyComptrName, ADDR szComptrName    
    invoke lstrcat, ADDR DsplyComptrName, ADDR LoclComptrNam   
    invoke lstrcat, ADDR DsplyComptrName, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyComptrName
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyComptrName, dwlenDtWrt, ADDR dwlenNmWrt, NULL

;***************************************************************************************************
;  By default, the token that is associated with a thread is that of its containing 
;  process. This "user context" is superceded by any token that is attached directly 
;  to the thread. Therefore, to determine a thread's user context, you should first 
;  attempt to obtain a token for the thread with the OpenThreadToken function. If 
;  this method fails and the GetLastError function reports ERROR_NO_TOKEN, then  
;  you can obtain the token for the process with the OpenProcessToken function.
;  The return value of GetCurrentThread is a pseudo handle for the current thread.    
;  The pseudo handle need not be closed when it is no longer needed.   
;***************************************************************************************************

    invoke GetCurrentThread    
    MOV hCurThread, eax    
    invoke OpenThreadToken, hCurThread, TOKEN_ALL_ACCESS, FALSE, ADDR hThrdTokn
;  We expect this function to fail, with a ERROR_NO_TOKEN error; it usually does.    
    CMP eax, 0
    JNZ ChckPrcssTkn    ;  Actually, this is incorrect. You want to code to handle the Thread Token.    
    invoke GetLastError    
    MOV dwLastError, eax
    .IF dwLastError==ERROR_NO_TOKEN
    JMP ChckPrcssTkn
    .ENDIF    

    .IF dwLastError==ERROR_ACCESS_DENIED    
;  You probably want to abort the operation if you get Access Denied.    
    invoke lstrlen, ADDR szErrTknAcsDend
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrTknAcsDend, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET
    .ENDIF   

ChckPrcssTkn:    
    invoke GetCurrentProcess
    MOV hCurProcess, eax    
    invoke OpenProcessToken, hCurProcess, TOKEN_ALL_ACCESS, ADDR hProcssTokn
    CMP eax, 0
    JNZ ChckTknInfo
    invoke GetLastError    
    MOV dwLastError, eax
    CMP dwLastError, ERROR_NO_TOKEN
    JNZ MskQueryTkn
    invoke lstrlen, ADDR szErrOpnProcsTkn
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrOpnProcsTkn, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET    

MskQueryTkn:
;  Try OpenProcessToken again with a reduced TOKEN_QUERY access mask
    invoke OpenProcessToken, hCurProcess, TOKEN_QUERY, ADDR hProcssTokn
    CMP eax, 0    ;  If OpenProcessToken, the return value is zero
    JNZ ChckTknInfo
    invoke lstrlen, ADDR szErrOpnProcsTkn
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrOpnProcsTkn, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET    ;  Cannot proceed without access to Process token

ChckTknInfo:
;  If you call GetTokenInformation and provide a memory buffer that is initialized in the .data segment    
;  above, the function will fail and GetLastError will return 998 (invalid access to memory location).    
;  For example:    if you define    UserToknInfo BYTE 256 DUP(0)    in the data segment, and invoke,  
;      GetTokenInformation, hProcssTokn, TokenUser, ADDR UserToknInfo, 256, ADDR dwSizToknUsr
;  We must first call GetTokenInformation with NULL pointer to get size required for memory buffer.    

    invoke GetTokenInformation, hProcssTokn, TokenUser, NULL, 0, ADDR dwSizToknUsr
;  GetTokenInformation will return a failure code here. But the size of the required memory is returned.    
    CMP eax, 0    ;  If GetTokenInformation fails, the return value is zero.     
    invoke GetLastError
    MOV dwLastError, eax
    CMP dwLastError, ERROR_INSUFFICIENT_BUFFER
    JNZ UnknownErr

;  This next call to GetTokenInformation is to get info to determine if user has Administrative privileges.     
    invoke GetTokenInformation, hProcssTokn, TokenGroups, NULL, 0, ADDR dwToknGrpsSiz
    CMP eax, 0    ;  If GetTokenInformation fails, the return value is zero.     
    invoke GetLastError
    MOV dwLastError, eax
    CMP dwLastError, ERROR_INSUFFICIENT_BUFFER
    JNZ UnknownErr

    invoke GetProcessHeap
    MOV hProcssHeap, eax
    CMP eax, 0    
    JZ TknInfoErr
    invoke HeapAlloc, hProcssHeap, HEAP_ZERO_MEMORY, dwSizToknUsr
    MOV lpToknUserInfo, eax
;  If HeapAlloc fails and you have not specified HEAP_GENERATE_EXCEPTIONS, the return value is NULL.
;  To determine the actual size of the allocated block, use the HeapSize function. 
    CMP eax, 0
    JZ ErrHeapAlloc
    invoke HeapAlloc, hProcssHeap, HEAP_ZERO_MEMORY, dwToknGrpsSiz
    MOV lpTokGroupsInf, eax
;  If HeapAlloc fails and you have not specified HEAP_GENERATE_EXCEPTIONS, the return value is NULL.
;  To determine the actual size of the allocated block, use the HeapSize function. 
    CMP eax, 0
    JZ ErrHeapAlloc

    invoke GetTokenInformation, hProcssTokn, TokenUser, lpToknUserInfo, dwSizToknUsr, ADDR dwSizToknUsr
    CMP eax, 0    ;  If GetTokenInformation fails, the return value is zero.
    JZ TknInfoErr
    invoke GetTokenInformation, hProcssTokn, TokenGroups, lpTokGroupsInf, dwToknGrpsSiz, ADDR dwToknGrpsSiz
    CMP eax, 0    ;  If GetTokenInformation fails, the return value is zero.
    JNZ ChckUsrSid

TknInfoErr:    
    invoke GetLastError
    MOV dwLastError, eax
    invoke lstrlen, ADDR szErrGetTknInfo
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrGetTknInfo, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    invoke RtlZeroMemory, ADDR  DsplyErrNumbr, 128
    invoke RtlZeroMemory, ADDR  TknErrNumbr, 16
    invoke DwtoA, dwLastError, ADDR TknErrNumbr
    invoke lstrcpy, ADDR DsplyErrNumbr, ADDR szGetLstErr    
    invoke lstrcat, ADDR DsplyErrNumbr, ADDR TknErrNumbr   
    invoke lstrcat, ADDR DsplyErrNumbr, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyErrNumbr
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyErrNumbr, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET    ;  Error, we cannot proceed.   

UnknownErr:
    invoke lstrlen, ADDR szErrUnknwnTkn
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrUnknwnTkn, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    invoke RtlZeroMemory, ADDR  DsplyErrNumbr, 128
    invoke RtlZeroMemory, ADDR  TknErrNumbr, 16
    invoke DwtoA, dwLastError, ADDR TknErrNumbr
    invoke lstrcpy, ADDR DsplyErrNumbr, ADDR szGetLstErr    
    invoke lstrcat, ADDR DsplyErrNumbr, ADDR TknErrNumbr   
    invoke lstrcat, ADDR DsplyErrNumbr, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyErrNumbr
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyErrNumbr, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET

ErrHeapAlloc:    
    invoke GetLastError
    MOV dwLastError, eax
    invoke RtlZeroMemory, ADDR  DsplyErrNumbr, 128
    invoke RtlZeroMemory, ADDR  TknErrNumbr, 16
    invoke lstrlen, ADDR szErrHeapAlloc
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrHeapAlloc, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    invoke DwtoA, dwLastError, ADDR TknErrNumbr
    invoke lstrcpy, ADDR DsplyErrNumbr, ADDR szGetLstErr    
    invoke lstrcat, ADDR DsplyErrNumbr, ADDR TknErrNumbr   
    invoke lstrcat, ADDR DsplyErrNumbr, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyErrNumbr
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyErrNumbr, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET

;***************************************************************************************************
;  A number of Privileges are granted to System Administrators (and all members of the    
;  Administrators Group) by default. This number varies with the Windows Operating      
;  System version. In Windows XP Professional, Administrators are granted about 20     
;  Privileges, normally disabled by default. If a caller's token hasn't been granted the       
;  requested privilege (the privilege is NOT listed in the user token, which     
;  GetTokenInformation will enumerate), a call to AdjustTokenPrivileges will quietly     
;  succeed, but GetLastError will return ERROR_NOT_ALL_ASSIGNED. Note from,   
;  Microsoft Windows Internals, Fourth Edition, by David Solomon and Mark Russinovich.       
;  Super Privileges: Several privileges are so powerful that a user to which they are       
;  assigned is effectively a "super user" who has full control over a computer. They are:      
;  Debug Programs (SeDebugPrivilege), Take Ownership (SeTakeOwnershipPrivilege),  
;  Restore Files and Directories (SeRestorePrivilege), Load and Unload Device Drivers     
;  (SeLoadDriverPrivilege), Create a Token Object (SeCreateTokenPrivilege), and 
;  Act As a Part of the Operating System (SeTcbPrivilege). These privileges can be     
;  used in an infinite number of ways to gain unauthorized access to otherwise off-limit    
;  resources and to perform unauthorized operations. This capability can be leveraged 
;  to perform any operation on the local machine that the user desires. Note that the use 
;  of elevated privilege does not extend past the machine boundary to the network, 
;  because any interaction with another computer requires authentication with a domain 
;  controller and validation of domain passwords.    
;***************************************************************************************************

ChckUsrSid:    
;  Get the pointer to the Token User SID, so that LookupAccountSid can be invoked.    
;  A SID is a variable length structute. A TOKEN_USER structure consists of a 
;  SID_AND_ATTRIBUTES structure. The first field of this is a pointer to the SID.    

    MOV eax, lpToknUserInfo
    MOV ebx, [eax]
    MOV dwpUserSID, ebx    

;  Check to determine that we have correctly retrieved the SID. 
;  If the SID structure is not valid, the return value is zero.    
    invoke IsValidSid, dwpUserSID
    .IF eax==0
    invoke lstrlen, ADDR szNotValidSid
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szNotValidSid, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET    
    .ENDIF

    MOV eax, OFFSET AccountNameSid
    MOV lpAccntName, eax 
    MOV eax, OFFSET DomainNameSid 
    MOV lpDomainName, eax
;  Length of both string buffers (AccountNameSid and DomainNameSid) is 128 bytes.
    MOV eax, 128    
    MOV dwAccntName, eax
    MOV dwDomainNam, eax    
    invoke LookupAccountSid, NULL, dwpUserSID, lpAccntName, ADDR dwAccntName, lpDomainName, ADDR dwDomainNam, ADDR dwTypSecDescrp
;  If LookupAccountSid fails, the return value is zero. Check for failure.        
    .IF eax==0
    invoke lstrlen, ADDR szErrLkupAccntSid
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrLkupAccntSid, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET    
    .ENDIF    

    invoke lstrcpy, ADDR DsplyAccntName, ADDR szSidAccntNam
    invoke lstrcat, ADDR DsplyAccntName, ADDR AccountNameSid  
    invoke lstrcat, ADDR DsplyAccntName, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyAccntName   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyAccntName, dwlenDtWrt, ADDR dwlenNmWrt, NULL

    invoke lstrcpy, ADDR DsplyDomainNm, ADDR szDomanNam
    invoke lstrcat, ADDR DsplyDomainNm, ADDR DomainNameSid 
    invoke lstrcat, ADDR DsplyDomainNm, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyDomainNm   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyDomainNm, dwlenDtWrt, ADDR dwlenNmWrt, NULL

    MOV eax, OFFSET UserSIDStrng    
    MOV lpUserSid, eax
    
;    The function: ConvertSidToStringSid is included in Windows 2000 and later. To correctly    
;    use this function, you should call: LoadLibrary (Advapi32.dll), and then, GetProcAddress    
;    to determine if the functionality exists on the Local System. I have done so here as an    
;    example of how to correctly make this determination without crashing the application.        

    MOV eax, 0    
    MOV lpWindwsDir, eax
    MOV lpPathLoadDll, eax
    invoke RtlZeroMemory, ADDR LoadLibName, 128
    invoke RtlZeroMemory, ADDR ProcAddrName, 64
    invoke RtlZeroMemory, ADDR CurWindwsDir, 128
    MOV eax, OFFSET LoadLibName
    MOV lpPathLoadDll, eax
    MOV eax, OFFSET CurWindwsDir
    MOV lpWindwsDir, eax
    MOV eax, OFFSET ProcAddrName
    MOV lpProcName, eax
    invoke GetSystemDirectory, lpWindwsDir, 128
    invoke lstrcpy, lpPathLoadDll, lpWindwsDir
    invoke lstrcat, lpPathLoadDll, ADDR szAdvApiLib 
    invoke LoadLibrary, lpPathLoadDll
    MOV hAdvApiLib, eax    
    CMP hAdvApiLib, 0
    JNZ GetProcAddr
    invoke lstrlen, ADDR szErrLoadAdvLib   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrLoadAdvLib, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hProcssTokn
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    
    RET

GetProcAddr:   
    invoke lstrcpy, lpProcName, ADDR szCnvSidToStr
    invoke GetProcAddress, hAdvApiLib, lpProcName    
    CMP eax, 0
    JNZ CnvrtSidStr
    invoke lstrlen, ADDR szErrGetProcAddr   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrGetProcAddr, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hProcssTokn
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    
    RET

CnvrtSidStr:
    MOV eax, 0
    MOV hAdvApiLib, eax
    invoke ConvertSidToStringSid, dwpUserSID, ADDR lpUserSid    ;  The second parameter is a pointer to a LPTSTR.
;  If ConvertSidToStringSid fails, the return value is zero.    
    .IF eax==0
    invoke lstrlen, ADDR szErrConvrtSidStr   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrConvrtSidStr, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET
    .ENDIF

;  Check to see if the SID has actually been written to the memory buffer.    
;  The length of the User SID in character bytes is usually about 28.    
    invoke lstrlen, lpUserSid
    .IF eax==0
    invoke lstrlen, ADDR szErrSidZeroLen   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrSidZeroLen, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET
    .ENDIF       

    invoke lstrcpy, ADDR DsplyUserSIDStr, ADDR szUserSid 
    invoke lstrcat, ADDR DsplyUserSIDStr, lpUserSid 
    invoke lstrcat, ADDR DsplyUserSIDStr, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyUserSIDStr   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyUserSIDStr, dwlenDtWrt, ADDR dwlenNmWrt, NULL

;  Check if the current user has Adminstrative privileges and any Super Privileges enabled.    
;  This procedure uses the technique demonstrated in the SDK documentation.    
;  Initially, Create a SID for the BUILTIN\Administrators group. Call FreeSid at end.    

    invoke AllocateAndInitializeSid, ADDR AuthrtySid, 2, SECURITY_BUILTIN_DOMAIN_RID, 
                                                            DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, ADDR dwpAdminGrpSid
    .IF eax==0
    invoke lstrlen, ADDR szErrInitAdminSid   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrInitAdminSid, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET    
    .ENDIF 

;    Check the Administrator Group SID created with AllocateAndInitializeSid.    
    invoke IsValidSid, dwpAdminGrpSid    ;    If the SID structure is valid, the return value is nonzero.
    CMP eax, 0
    JZ ErrNotValid

;    Loop to iterate through all the SIDs and attributes of the TOKEN_GROUPS 
;    returned from GetTokenInformation. A TOKEN_GROUPS structure is a    
;    variable sized structure, composed of: a DWORD value, GroupCount, and    
;    an array of SID_AND_ATTRIBUTES structures, which is 8 bytes in size.     
;    There are a number of other methods for determining Administrative privileges.    
;    Search The MASM Forum for, ''Old test piece to determine administrative access.', started 
;    by hutch, in The Workshop, December 7, 2009. Tests several operating system versions.    

    MOV eax, 0
    MOV dwTknGrps, eax
    MOV ebx, lpTokGroupsInf
    MOV ecx, [ebx]    ;    TOKEN_GROUPS.GroupCount    DWORD size    
    ADD ebx, 4    ;    4 Bytes, this addresses the first PSID
    XOR esi, esi    

ChckAdmin:    ;    May want to call IsValidSid as a check.    

    push ecx
    MOV ecx, ebx
    MOV eax, 8    ;    SIZEOF SID_AND_ATTRIBUTES
    XOR edx, edx
    MUL esi    ;    esi * eax, result in eax
    ADD ecx, eax
    MOV edx, [ecx]    ;    The value at that address must be dereferenced.
    MOV dwTknGrps, ecx    ;    Save the current location in structure array.    
    invoke IsValidSid, edx    ;    If the SID structure is valid, the return value is nonzero.
    CMP eax, 0
    JZ ErrNotValid
    invoke EqualSid, dwpAdminGrpSid, edx
    pop ecx
    CMP eax, 0    ;    If the SID structures are equal, the return value is nonzero.
    JNZ ChckEnabld
    INC esi
    CMP esi, ecx
    JB ChckAdmin    ;    Comparison of unsigned integers (jump if, esi < ecx)
    JMP NoAdminPrvlgs
    
ChckEnabld:    
;    Just because a SID is present in the token, doesn't mean that the system will use it in an    
;    access check. The SID may be disabled or have the SE_GROUP_USE_FOR_DENY_ONLY     
;    attribute. The system uses only enabled SIDs to grant access when performing an access check.    

    MOV ebx, dwTknGrps
    ADD ebx, 4
    MOV edx, [ebx]    ;    Dereference the attribute of the SID_AND_ATTRIBUTES structure.    

;    The SE_GROUP_ENABLED attribute means that the SID is enabled for access checks. When  
;    the system performs an access check, it checks for access-allowed and access-denied ACEs 
;    that apply to the SID. A SID without this attribute is ignored during an access check unless 
;    the SE_GROUP_USE_FOR_DENY_ONLY attribute is set.

    AND edx, SE_GROUP_ENABLED
    CMP edx, SE_GROUP_ENABLED
    JNZ NoAdminPrvlgs
    invoke lstrlen, ADDR szAdminPrvlgs   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szAdminPrvlgs, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    
;    If administrative privileges are enabled, we want to enumerate them and write      
;    the data to the Info file, listing whether they are enabled or disabled also.    

    invoke GetTokenInformation, hProcssTokn, TokenPrivileges, NULL, 0, ADDR dwToknPrvlgsSiz
    CMP eax, 0    ;  If GetTokenInformation fails, the return value is zero.     
    invoke GetLastError
    MOV dwLastError, eax
    CMP dwLastError, ERROR_INSUFFICIENT_BUFFER
    JNZ UnknownErr
    invoke HeapAlloc, hProcssHeap, HEAP_ZERO_MEMORY, dwToknPrvlgsSiz
    MOV lpTknPrvlgsInfo, eax
;  If HeapAlloc fails and you have not specified HEAP_GENERATE_EXCEPTIONS, the return value is NULL.
;  To determine the actual size of the allocated block, use the HeapSize function. 
    CMP eax, 0
    JZ ErrHeapAlloc
    invoke GetTokenInformation, hProcssTokn, TokenPrivileges, lpTknPrvlgsInfo, dwToknPrvlgsSiz, ADDR dwToknPrvlgsSiz
    CMP eax, 0    ;  If GetTokenInformation fails, the return value is zero.
    JZ TknInfoErr
    invoke lstrlen, ADDR szEnumCurPrvlgs   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szEnumCurPrvlgs, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    
    MOV eax, 0
    MOV dwTknPrvlgs, eax
    MOV ebx, lpTknPrvlgsInfo
    MOV ecx, [ebx]    ;    TOKEN_PRIVILEGES.PrivilegeCount    DWORD size    
    MOV CntNumPrivlgs, ecx    ;    Save the number of Privileges.    
    ADD ebx, 4    ;    4 Bytes, this addresses the first LUID_AND_ATTRIBUTES    
    MOV dwTknPrvlgs, ebx    ;    dwTknPrvlgs is temporarily used here.    
    invoke RtlZeroMemory, ADDR DsplyNumPrvlgs, 64
    invoke RtlZeroMemory, ADDR NmbrPrvlgsStr, 16
    invoke DwtoA, CntNumPrivlgs, ADDR NmbrPrvlgsStr
    invoke lstrcpy, ADDR DsplyNumPrvlgs, ADDR szNumbrPrivlgs    
    invoke lstrcat, ADDR DsplyNumPrvlgs, ADDR NmbrPrvlgsStr   
    invoke lstrcat, ADDR DsplyNumPrvlgs, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyNumPrvlgs
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyNumPrvlgs, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    MOV ebx, dwTknPrvlgs
    XOR esi, esi    

;    Now loop through the LUID_AND_ATTRIBUTES structure array, and write data to file.    
ReadPrivlgs:
    push ebx
    MOV ecx, ebx
    MOV eax, 12    ;    SIZEOF LUID_AND_ATTRIBUTES    
    XOR edx, edx
    MUL esi    ;    esi * eax, result in eax
    ADD ecx, eax
    MOV dwTknPrvlgs, ecx    ;    Save the current location in structure array.    
    invoke RtlZeroMemory, ADDR LookupPrvlgName, 64
    MOV eax, OFFSET LookupPrvlgName
    MOV lpPrvlgName, eax
    MOV eax, 64
    MOV dwSizPrvlgNam, eax
    invoke LookupPrivilegeName, NULL, dwTknPrvlgs, lpPrvlgName, ADDR dwSizPrvlgNam
    CMP eax, 0
    JNZ LookUpGood
    pop ebx
    invoke lstrlen, ADDR szErrLookPrvlgNam   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrLookPrvlgNam, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    RET 
    
LookUpGood:
    invoke RtlZeroMemory, ADDR DsplyPrvlgEnabl, 128
    invoke lstrcpy,ADDR DsplyPrvlgEnabl, ADDR szTwoSpaces
    invoke lstrcat, ADDR DsplyPrvlgEnabl, lpPrvlgName   
    MOV eax, dwTknPrvlgs
    ADD eax, 8    ;    a LUID is 8 bytes.    
    MOV ebx, [eax]    ;    Dereference the attribute of the Privilege.    

    .IF ebx==0
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szPrvlgDisabld
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyPrvlgEnabl
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyPrvlgEnabl, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    JMP FlgDetrmnd
    .ELSE
    MOV ecx, ebx
    AND ebx, SE_PRIVILEGE_ENABLED_BY_DEFAULT
    CMP ebx, SE_PRIVILEGE_ENABLED_BY_DEFAULT
    JNZ ChckAttrbtFlg
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szPrvlgDefltEnbld
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyPrvlgEnabl
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyPrvlgEnabl, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    JMP FlgDetrmnd
    .ENDIF
    
ChckAttrbtFlg:   
    AND ecx, SE_PRIVILEGE_ENABLED
    CMP ecx, SE_PRIVILEGE_ENABLED
    JNZ UsedAccess
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szPrvlgEnabld
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyPrvlgEnabl
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyPrvlgEnabl, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    JMP FlgDetrmnd
    
UsedAccess:
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szPrvlgUsedAccess
    invoke lstrcat, ADDR DsplyPrvlgEnabl, ADDR szEndLine   
    invoke lstrlen, ADDR DsplyPrvlgEnabl
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR DsplyPrvlgEnabl, dwlenDtWrt, ADDR dwlenNmWrt, NULL

FlgDetrmnd:
    pop ebx
    MOV ecx, CntNumPrivlgs
    INC esi
    CMP esi, ecx
    JB ReadPrivlgs    ;    Comparison of unsigned integers (jump if, esi < ecx)
    JMP InfoCrrct

NoAdminPrvlgs:    
    invoke lstrlen, ADDR szNOAdminPrvlg   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szNOAdminPrvlg, dwlenDtWrt, ADDR dwlenNmWrt, NULL
    JMP InfoCrrct

ErrNotValid:
    invoke lstrlen, ADDR szNotValidSid   
    MOV dwlenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szNotValidSid, dwlenDtWrt, ADDR dwlenNmWrt, NULL

InfoCrrct: 
    invoke FreeSid, dwpAdminGrpSid
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hProcssTokn
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    

    RET    
ChckUserSecurity ENDP 

;***************************************************************************************************

ChckProcessrCapabilts PROC      
LOCAL dwLenDtWrt:DWORD
LOCAL dwLenNmWrt:DWORD    
LOCAL lpWindowsDrctry:DWORD
LOCAL lpPathKrnlDll: DWORD
LOCAL lpFeaturPresnt:DWORD

    MOV eax, OFFSET VersionInfoFile    
    MOV lpVerInfo, eax    
    invoke CreateFile, lpVerInfo, 0C0000000h, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL    
    .IF eax==INVALID_HANDLE_VALUE    ;  Check for CreateFile failure. The function fails if the file does not exist.     
     RET    
    .ENDIF    
    MOV hInfoFile, eax    
    invoke SetFilePointer, hInfoFile, dwCurFilePtr, NULL, FILE_BEGIN
    MOV dwCurFilePtr, eax    

    invoke RtlZeroMemory, ADDR LocalSystmInfo, 36    ;  SYSTEM_INFO Struct is 36 bytes.    
    invoke GetSystemInfo, ADDR LocalSystmInfo    
    
;   wProcessorArchitecture field of SYSTEM_INFO structure can be one of eight values.    
;  I have only handled notifications for five of them. This can be expanded if necessary.    
    .IF  LocalSystmInfo.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_UNKNOWN
    invoke lstrlen, ADDR szUnknwnPrcssr
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szUnknwnPrcssr, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF LocalSystmInfo.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_INTEL
    invoke lstrlen, ADDR szProcssr32Bit
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szProcssr32Bit, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF LocalSystmInfo.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_IA64
    invoke lstrlen, ADDR szPrcsr64BitWnd
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szPrcsr64BitWnd, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF LocalSystmInfo.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_AMD64
    invoke lstrlen, ADDR szPrcsr64BitAMD
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szPrcsr64BitAMD, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF LocalSystmInfo.wProcessorArchitecture==PROCESSOR_ARCHITECTURE_IA32_ON_WIN64
    invoke lstrlen, ADDR szProcr64BtWnds64
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szProcr64BtWnds64, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF      

;  Next code block uses the technique from, "Intel Processor Identification and the CPUID Instruction",    
;  to determine if the processor has the CPUID instruction available. It checks the ID flag of the EFLAGS.    

    XOR ebx, ebx
    XOR ecx, ecx
    PUSHFD    ;  push EFLAGS onto the stack    
    POP ecx
    MOV ebx, ecx
    XOR ebx, 200000h    ;  This changes the ID flag.    
    PUSH ebx
    POPFD    ;  pops the toggled value back into EFLAGs register.    
    PUSHFD    
    POP ebx    
    XOR ebx, ecx    ;  Compare to original EFLAGs value.    
    TEST ebx, 200000h    ;  Implied AND operation. Modifies zero flag.    
    JZ NoCpuIdent    ;  Zero flag is set if the ID flag (bit 21) in EFALGS could NOT be set.    
    invoke lstrlen, ADDR szCpuidInstrctn
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szCpuidInstrctn, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    JMP LocProcsrFeatr    

NoCpuIdent:    ;  The processor is early Intel 486 or older, with no CPUID instruction.    
    invoke lstrlen, ADDR szEarlyIntelPrcsr
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szEarlyIntelPrcsr, dwLenDtWrt, ADDR dwLenNmWrt, NULL

;  Windows documentation states that instead of using the wProcessorLevel  field of the SYSTEM_INFO    
;  structure, to determine processor capabilities, the function, IsProcessorFeaturePresent should be used.    
;  In the current documentation, there are 15 different Processor features that can be tested for.  
;  IsProcessorFeaturePresent is NOT supported on Windows 95, Windows 98, or Windows ME. Check first.       

LocProcsrFeatr:    
    MOV eax, 0    
    MOV hKrnl32Lib, eax    
    MOV lpWindowsDrctry, eax
    MOV lpPathKrnlDll, eax
    MOV lpFeaturPresnt, eax   
    invoke RtlZeroMemory, ADDR LoadLibName, 128
    invoke RtlZeroMemory, ADDR ProcAddrName, 64
    invoke RtlZeroMemory, ADDR CurWindwsDir, 128
    MOV eax, OFFSET LoadLibName
    MOV lpPathKrnlDll, eax
    MOV eax, OFFSET CurWindwsDir
    MOV lpWindowsDrctry, eax
    MOV eax, OFFSET ProcAddrName
    MOV lpFeaturPresnt, eax
    invoke GetSystemDirectory, lpWindowsDrctry, 128
    invoke lstrcpy, lpPathKrnlDll, lpWindowsDrctry
    invoke lstrcat, lpPathKrnlDll, ADDR szKernel32Lib 
    invoke LoadLibrary, lpPathKrnlDll
    MOV hKrnl32Lib, eax    
    CMP hKrnl32Lib, 0
    JNZ GetProFeatrPrsnt   
    invoke lstrlen, ADDR szErrLodKrnlLib   
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrLodKrnlLib, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    RET

GetProFeatrPrsnt:
;  Checks for exported function,  IsProcessorFeaturePresent, and writes error message if it is     
;  not. The CPUID instruction is NOT implemented on early models of the Intel 486 processor,    
;  and all earlier Intel processors. The .586 processor directive is required to use CPUID.       

    invoke lstrcpy, lpFeaturPresnt, ADDR szProcsrFeturPresnt
    invoke GetProcAddress, hKrnl32Lib, lpFeaturPresnt    
    CMP eax, 0
    JNZ ChckProcsrFeturs
    invoke lstrlen, ADDR szErrPrcsrFeaturPrsnt  
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szErrGetProcAddr, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    invoke lstrlen, ADDR szFnctNotSuportd  
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szFnctNotSuportd, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    RET

ChckProcsrFeturs:
    invoke IsProcessorFeaturePresent, PF_RDTSC_INSTRUCTION_AVAILABLE    
    .IF eax!=0    ;  Processor feature is supported (8).    
    invoke lstrlen, ADDR szRDTSCAvailable
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szRDTSCAvailable, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szRDTSCNotAvalbl
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szRDTSCNotAvalbl, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

;  SIMD Instructions: beginning with the Pentium II and Pentium with MMX technology processor families,     
;  six extensions have been introduced into the Intel-64 and IA-32 architectures to perform single-    
;  instruction multiple data (SIMD) operations. Each of these extensions provides a group of instructions     
;  that perform SIMD operations on packed integer and/or packed floating point data elements.    

    invoke IsProcessorFeaturePresent, PF_MMX_INSTRUCTIONS_AVAILABLE   
;  Intel MMX technology was introduced in the Pentium II and Pentium with MMX technology processor families.    
    .IF eax!=0    ;  Processor feature, MMX instruction set is supported (3).    
    invoke lstrlen, ADDR szMMXInstrctnAvailbl
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szMMXInstrctnAvailbl, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szMMXInstrNotAvalbl
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szMMXInstrNotAvalbl, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

    invoke IsProcessorFeaturePresent, PF_XMMI_INSTRUCTIONS_AVAILABLE  
;  SSE extensions were introduced in the Pentium III processor family.    
    .IF eax!=0    ;  Processor feature, SSE instruction set is supported (6).    
    invoke lstrlen, ADDR szSSEInstrctnAvailbl
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szSSEInstrctnAvailbl, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szSSEInstnNotAvalbl
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szSSEInstnNotAvalbl, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

    invoke IsProcessorFeaturePresent, PF_XMMI64_INSTRUCTIONS_AVAILABLE  
;  SSE2 extensions were introduced in Pentium 4 and Intel Xeon processors.    
    .IF eax!=0    ;  Processor feature, The SSE2 instruction set is available. (10).    
    invoke lstrlen, ADDR szSSE2AvailbInstns
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szSSE2AvailbInstns, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szNOSSE2InstrnSet
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szNOSSE2InstrnSet, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

    invoke IsProcessorFeaturePresent, PF_SSE3_INSTRUCTIONS_AVAILABLE   
;  This feature is not supported on Windows Server 2003 and Windows XP/2000, and will return zero.    
;  SSE3 extensions were introduced with the Pentium 4 processor supporting Hyper-Threading technology.    
    .IF eax!=0    ;  Processor feature, The SSE3 instruction set is available. (13).    
    invoke lstrlen, ADDR szSSE3InsrtnSetSprt
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szSSE3InsrtnSetSprt, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szNoSSE3InsrtnSet
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szNoSSE3InsrtnSet, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

    invoke IsProcessorFeaturePresent, PF_PAE_ENABLED   
;  All x64 processors always return a nonzero value for this feature.    
    .IF eax!=0    ;  Processor feature, The processor is Physical Address Extension-enabled(9).    
    invoke lstrlen, ADDR szPhyslAddrExtSup
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szPhyslAddrExtSup, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szNOPAESupprt
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szNOPAESupprt, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

    invoke IsProcessorFeaturePresent, PF_NX_ENABLED  
    .IF eax!=0    ;  Processor feature, Data Execution Prevention (DEP) is supported (12).    
    invoke lstrlen, ADDR szDEPProtctAvabl
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szDEPProtctAvabl, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ELSEIF eax==0
    invoke lstrlen, ADDR szDEPNotAvailable
    MOV dwLenDtWrt, eax
    invoke WriteFile, hInfoFile, ADDR szDEPNotAvailable, dwLenDtWrt, ADDR dwLenNmWrt, NULL
    .ENDIF

;  A much more extensive listing of processor features can be determined by using the CPUID instruction,    
;  and checking the feature flags. This instruction requires that the .586 processor directive be used.    

    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    

    RET    
ChckProcessrCapabilts   ENDP

;***************************************************************************************************
;    IMPORTANT NOTE:  The OSVERSIONINFOEX STRUCT definition in windows.inc., is     
;    NOT the same as that structure defined in Platform SDK C++ header files, although    
;    the size of the structure is correct. The difference is trivial. I have defined a new    
;    structure at the beginning of this file to make re-compiling the DLL convenient. The
;    new definition includes the fields: wSuiteMask (WORD) , and wProductType (BYTE).    
;    In the existing windows.inc file, the last field is: wReserved, which is initialized as:    
;    WORD DUP 2(?). I replaced it with:   wSuiteMask WORD ?  wProductType BYTE ?  
;    and,  wReserved BYTE ?, to be consistent with the SDK definition. This is also     
;    easier to use when accessing the wSuiteMask and wProductType fields of the    
;    OSVERSIONINFOEXsdk structure. The thinking here is that if you want to use
;    just a part of this library, you can merely copy those elements of interest, without
;    having to actually re-write any of the code. These routines could be used within 
;    a MASM executable, without having to re-compile the DLL and either link to the
;    library, or call LoadLibrary and GetProcAddress to execute the functions.    
;***************************************************************************************************
  
ChckOperSysVersion PROC
LOCAL dwOSVersn:DWORD
LOCAL dwLenWrtFile:DWORD
LOCAL dwLenNumWrt:DWORD    
LOCAL lpWinSysDir:DWORD
LOCAL lpPathKrnlDll:DWORD
LOCAL lpPrdctInfoNam:DWORD    
LOCAL dwAddrPrdctInfo:DWORD
LOCAL lpVistaEdtn:DWORD
LOCAL lpWinSevnEdtn:DWORD

    MOV eax, 0
    MOV dwOSVersn, eax
    MOV eax, OFFSET VersionInfoFile    
    MOV lpVerInfo, eax    
    invoke CreateFile, lpVerInfo, 0C0000000h, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL    
    .IF eax==INVALID_HANDLE_VALUE    ;  Check for CreateFile failure. The function fails if the file does not exist.       
     RET    
    .ENDIF    
    MOV hInfoFile, eax    
    invoke SetFilePointer, hInfoFile, dwCurFilePtr, NULL, FILE_BEGIN
    MOV dwCurFilePtr, eax    
    
;  This routine may need the data in the SYSTEM_INFO structure later on. This is a check.    
    .IF LocalSystmInfo.dwPageSize==0    ;    ChckProcessrCapabilts has NOT been called yet.          
    invoke RtlZeroMemory, ADDR LocalSystmInfo, 36    ;  SYSTEM_INFO Struct is 36 bytes.    
    invoke GetSystemInfo, ADDR LocalSystmInfo    
    .ENDIF    

;  User Mode function GetVersionEx fills OSVERSIONINFOEX structure with data. This        
;  will fail on Windows Versions 95/98/Me. Use the OSVERSIONINFO structure instead.    
;  The OSVERSIONINFOEX structure is available on Windows NT 4.0 SP6 and later.     
;  Windows comes in an ever-increasing variety of editions. Kernel Mode programmers     
;  have easy access to the Product Suite through similar function: RtlGetVersion.  

;  Before calling the GetVersionEx function, Set the dwOSVersionInfoSize member      
;  to sizeof (OSVERSIONINFOEX) to identify the structure type:    156 bytes.         

    MOV eax, 156    ;  This is size of OSVERSIONINFOEX structure.    
    MOV LoclOperatSystem.dwOSVersionInfoSize, eax    

;  If GetVersionEx fails, the return value is zero. 
    invoke GetVersionEx, ADDR LoclOperatSystem
    .IF eax!=0
    MOV eax, 156
    MOV dwOSVersn, eax
    JNZ DetermnVersn
    .ENDIF

    MOV eax, 148
    MOV Win98VerInfo.dwOSVersionInfoSize, eax    ;  This is size of OSVERSIONINFO structure.
    invoke GetVersionEx, ADDR Win98VerInfo
    .IF eax!=0
    MOV eax, 148
    MOV dwOSVersn, eax
    JNZ DetermnVersn
    .ENDIF
    invoke lstrlen, ADDR szErrGetVersion
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szErrGetVersion, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    RET   
    
DetermnVersn:
    CMP dwOSVersn, 148    ;  Check for older Windows 85, 98, or Me
    JNZ ExtndWinVer
    
;  Otherwise, the Operating System Version is Windows 95 or Windows 98, or Windows Millennium Edition.    
    CMP Win98VerInfo.dwPlatformId, VER_PLATFORM_WIN32_WINDOWS    ;  (1) These are still out there.    
    JNZ WinNT4    ;  If JNZ, then syetem is: Windows NT 3.51 or, Windows NT 4.0.    
    CMP Win98VerInfo.dwMajorVersion, 4
    JNZ Win3NT    ;  Windows NT 3.51 has dwMajorVersion = 3    

    .IF Win98VerInfo.dwMinorVersion==0
    invoke lstrlen, ADDR szOSWinOld95
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szOSWinOld95, dwLenWrtFile, ADDR dwLenWrtFile, NULL
    JMP BuildNumbr
    .ELSEIF Win98VerInfo.dwMinorVersion==10   
    invoke lstrlen, ADDR szOldOSWin98
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szOldOSWin98, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF Win98VerInfo.dwMinorVersion==90    ;  Very Rare, almost never encounter.    
    invoke lstrlen, ADDR szOSWinMEOld
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szOSWinMEOld, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF    

WinNT4:
;  Windows NT 4.0 has both a Workstation and Server version; I have only identified the workstation version here.    
    CMP Win98VerInfo.dwPlatformId, VER_PLATFORM_WIN32_NT
    JNZ ErrUnknwnOS
    CMP Win98VerInfo.dwMajorVersion, 4
    JNZ Win3NT
    invoke lstrlen, ADDR szWinNT4OldOS
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinNT4OldOS, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

Win3NT:    
;  GetVersionEx is first implemented on NT 3.5, so earlier systems will NOT be identified.    
;  Windows NT 3.5 has both a Workstation and Server version; I have only identified the workstation version here.    
    CMP Win98VerInfo.dwMajorVersion, 3
    JNZ ErrUnknwnOS
    invoke lstrlen, ADDR szOldWinNT3OS
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szOldWinNT3OS, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

;  There is no need to check here for Windows 2000, Windows XP, or Windows .NET Server 
;  Operating Systems because GetVersionEx is invoked first with the OSVERSIONINFOEX 
;  structure, which will succeed and provide better Operating System information.    

ErrUnknwnOS:
    invoke lstrlen, ADDR szUnknwnOprSys
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szUnknwnOprSys, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP OSVerCorrct

ExtndWinVer:    
;  Windows NT 4.0 has both a Workstation and a Server version. I have made no attempt to identify the 
;  Server Version here, but, if you want to add that capability, compare wProductType to VER_NT_SERVER.    
    CMP LoclOperatSystem.dwMajorVersion, 4
    JNZ MajVerFive
    .IF LoclOperatSystem.wProductType==VER_NT_WORKSTATION
    invoke lstrlen, ADDR szWinNT4WrkStatn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinNT4WrkStatn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF    
    JMP ErrUnknwnOS
    
MajVerFive:    
;  OSVERSIONINFOEX, dwMajorVersion = 5, is Windows 2000, Windows XP, or Windows .NET Server
    CMP LoclOperatSystem.dwMajorVersion, 6
    JZ MajVerSix    ;  dwMajorVersion = 6, designates Windows 7 and Windows Vista. There is no dwMajorVersion = 7.        
    CMP LoclOperatSystem.dwMinorVersion, 0    ;  Windows 2000
    JNZ WinVerXP
    CMP LoclOperatSystem.wProductType, VER_NT_WORKSTATION
    JNZ Win2KDatCntr
    invoke lstrlen, ADDR szWin2KProfessnl
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2KProfessnl, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

Win2KDatCntr:    
;  I originally wrote code using CMP for the wSuiteMask field, assuming that there would only be     
;  one mask value comprising the wSuiteMask field. This is incorrect. The wSuiteMask member  
;  can be composed of any of 13 different values, and basing a conditional jump on the value of the     
;  zero flag doesn't work if there are several bit masks identifying the product suites available.    

    CMP LoclOperatSystem.wProductType, VER_NT_WORKSTATION
    JZ GenWin2k
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_DATACENTER    ;  0x00000080    
    .IF ax==0080h
    invoke lstrlen, ADDR szWin2KDtCntrSrv
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2KDtCntrSrv, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF    

Win2KAdvSrv:
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_ENTERPRISE    ;  0x00000002    
    .IF ax==0002h
    invoke lstrlen, ADDR szWin2KAdvdSrvr
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2KAdvdSrvr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF    
    
Win2KSrvr:    
    CMP LoclOperatSystem.wProductType, VER_NT_SERVER
    JNZ GenWin2k
    invoke lstrlen, ADDR szWin2KSrvr
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2KSrvr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

GenWin2k:    
;  I don't think there is a client version of Windows 2000 other than Windows 2000 Professional.    
;  But, this label exists just in case the above code fails to correctly identify the Windows 2000 version.    
    invoke lstrlen, ADDR szWin2KUnknClnt
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2KUnknClnt, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP OSVerCorrct

WinVerXP:    
;  Windows XP and Windows .NET Server have the same Major and Minor Version = 5.1    
    CMP LoclOperatSystem.dwMinorVersion, 1
    JNZ VerFive2003    ;  Four different versions have Minor Version = 2    
    invoke GetSystemMetrics, SM_MEDIACENTER
    .IF eax!=0
    invoke lstrlen, ADDR szWinXPMdiaCntr
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinXPMdiaCntr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF
    CMP LoclOperatSystem.wProductType, VER_NT_WORKSTATION
    JNZ WinNETSrvr
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_PERSONAL    ; 0x00000200    
    .IF ax==0200h
    invoke lstrlen, ADDR szWinXPHomEd
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinXPHomEd, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF    

WinXPPro:
    CMP LoclOperatSystem.wProductType, VER_NT_SERVER
    JZ WinNETSrvr
    invoke lstrlen, ADDR szWinXPProfessnl
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinXPProfessnl, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

WinNETSrvr:
;  Unknown if this Windows version even exists. It is the NET Server version of Windows XP Professional.    
;  The older documentation lists it as: Makor = 5, Minor = 1. presumably with wProductType = VER_NT_SERVER     
;  I suspect that this Major version, Minor version is incorrect, and Windows .NET Server is actually 
;  Windows Server 2003. This remains to be verfied, though. For now, I am ignoring it completely.    
    JMP OSVerCorrct

;    IMPORTANT: Have NOT checked for 64-Bit Itanium-based Systems.     
;    (OSVERSIONINFOEX wProductType != VER_NT_WORKSTATION )
;    (SYSTEM_INFO wProcessorArchitecture==PROCESSOR_ARCHITECTURE_IA64).    

VerFive2003:    ;    There are four different versions with Major=5, Minor=2    
    CMP LocalSystmInfo.wProcessorArchitecture, PROCESSOR_ARCHITECTURE_AMD64
    JZ XPProVer64Bit
    CMP  LoclOperatSystem.wProductType, VER_NT_SERVER
    JZ Win2003Srvr
;  If GetSystemMetrics succeeds, the return value is the requested system metric or   
;  configuration setting. If GetSystemMetrics fails, the return value is zero.     
    invoke GetSystemMetrics, SM_SERVERR2
    .IF eax!=0
    JMP WinSrvr2003R2
    .ENDIF

XPProVer64Bit:    ;  Major Version = 5    and, Minor Version = 2    
;  There are three Windows Server 2003 Versions with Major Version = 5 and, Minor Version = 2    
    CMP LoclOperatSystem.dwMinorVersion, 2
    JNZ UnkwnVerFiv
    invoke lstrlen, ADDR szWinXPPro64BitEd
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinXPPro64BitEd, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

Win2003Srvr:    
;  There are four additional Windows Server 2003 editions, differentiated with wSuiteMask.    
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_WH_SERVER    ;   0x00008000   
    .IF ax==8000h
    JMP WinHomeSrvr
    .ENDIF    
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_DATACENTER    ;   0x00000080   
    .IF ax==0080h
    JMP Win2003Datcntr
    .ENDIF    
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_ENTERPRISE    ;   0x00000002   
    .IF ax==0002h
    JMP Win2003Entrpris
    .ENDIF    
    XOR eax, eax    
    MOV ax, LoclOperatSystem. wSuiteMask
    AND ax, VER_SUITE_BLADE    ;  0x00000400  
    .IF ax==0400h
    JMP Win2003Web
    .ENDIF    
    
;  Otherwise, we assumde that it is the Windows 2003 Server Standard Edition.    
    invoke lstrlen, ADDR szWinServr2003
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinServr2003, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

WinHomeSrvr:    
    invoke lstrlen, ADDR szWinHomeSrvr
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWinHomeSrvr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

Win2003Datcntr:    ;  Available in both 32-bit and 64-bit versions.    
    invoke lstrlen, ADDR szWin2003DatCntr
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2003DatCntr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

Win2003Entrpris:    ;  Designed specifically for 64-bit Intel Itanium hardware.    
    invoke lstrlen, ADDR szWin2003Entrprs
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2003Entrprs, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

Win2003Web:    
    invoke lstrlen, ADDR szWin2003WebSrvr
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2003WebSrvr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

WinSrvr2003R2:    
    invoke lstrlen, ADDR szWin2003ServrR2
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szWin2003ServrR2, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr

UnkwnVerFiv:
    invoke lstrlen, ADDR szUnknwnOprSys
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szUnknwnOprSys, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP OSVerCorrct

MajVerSix:    ;    dwMajorVersion = 6 designates Windows Vista, Windows Server 2008, and Windows 7.    

;    The following block invokes LoadLibrary, and then GetProcAddress.    

    MOV eax, 0    
    MOV lpWinSysDir, eax
    MOV lpPathKrnlDll, eax
    MOV dwAddrPrdctInfo, eax
    invoke RtlZeroMemory, ADDR LoadLibName, 128
    invoke RtlZeroMemory, ADDR ProcAddrName, 64
    invoke RtlZeroMemory, ADDR CurWindwsDir, 128
    MOV eax, OFFSET LoadLibName
    MOV lpPathKrnlDll, eax
    MOV eax, OFFSET CurWindwsDir
    MOV lpWinSysDir, eax
    MOV eax, OFFSET ProcAddrName
    MOV lpPrdctInfoNam, eax
    invoke GetSystemDirectory, lpWinSysDir, 128
    invoke lstrcpy, lpPathKrnlDll, lpWinSysDir
    invoke lstrcat, lpPathKrnlDll, ADDR szKernel32Lib 
    invoke LoadLibrary, lpPathKrnlDll
    MOV hKrnl32Lib, eax    
    CMP hKrnl32Lib, 0
    JNZ PrcAdrPrdctInf
    invoke lstrlen, ADDR szErrLodKrnlLib   
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szErrLodKrnlLib, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hProcssTokn
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    
    RET

PrcAdrPrdctInf:
    invoke lstrcpy, lpPrdctInfoNam, ADDR szGetProdctInfo
    invoke GetProcAddress, hKrnl32Lib, lpPrdctInfoNam     
    MOV dwAddrPrdctInfo, eax
    CMP eax, 0
    JNZ GtPrdctInfo
    invoke lstrlen, ADDR szErrGetProdctInf   
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szErrGetProdctInf, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    RET   ;    Temporary, may eventually go on without this information.        

GtPrdctInfo:
;    There are five DWORD sized parameters that must be pushed on the stack in     
;    reverse order. The returned DWORD VALUE is a pointer to a DWORD.    

    MOV eax, OFFSET dwRtrnProdctTyp    ;    This parameter cannot be NULL
    push eax
    MOVZX eax, LoclOperatSystem.wServicePackMinor    ;    The minimum value is 0.
    push eax
    MOVZX eax, LoclOperatSystem.wServicePackMajor    ;     The minimum value is 0.
    push eax
    MOV eax, LoclOperatSystem.dwMinorVersion    ;    The minimum value is 0.
    push eax
    MOV eax, LoclOperatSystem.dwMajorVersion    ;    The minimum value is 6.
    push eax
    CALL dwAddrPrdctInfo
;    This function fails if one of the input parameters is invalid. Check for error.    
    CMP eax, 0    ;    If the function fails, the return value is zero.     
    JNZ SixChkMinVer
    invoke lstrlen, ADDR szErRtnGtPrdtInfo   
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szErRtnGtPrdtInfo, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    RET   ;    Abort this function if this block of code executes incorrectly.    

SixChkMinVer:
    CMP LoclOperatSystem.dwMinorVersion, 0    ;  dwMajorVersion = 6  dwMinorVersion = 0  is Windows Vista     
    JZ WinVista
;  dwMajorVersion = 6  dwMinorVersion = 1  is Windows Seven or Windows Server 2008 R2.     
    CMP LoclOperatSystem.dwMinorVersion, 1    
    JZ WinSeven

;    Windows Vista ships in eight editions. All editions except Windows Vista Starter support both 32-bit (x86) and 64-bit    
;    (x64) processor architectures. The function: GetProductInfo requires Windows Vista as the minimum supported client.    

WinVista:      ;   I have NOT checked for OSVERSIONINFOEX.wProductType = VER_NT_DOMAIN_CONTROLLER.     

    CMP LoclOperatSystem.wProductType, VER_NT_WORKSTATION
    JNZ WinSrvr2008
;    Build the string that correctly describes the Vista edition.    
    invoke RtlZeroMemory, ADDR DsplVistaVerEdtn, 128
    MOV eax, OFFSET DsplVistaVerEdtn
    MOV lpVistaEdtn, eax
    invoke lstrcpy, ADDR DsplVistaVerEdtn, ADDR szWinVistaWrkStn
    JMP AddVstaEditn
    
WinSrvr2008:    
;    Build the string that correctly describes the Vista edition.    
    invoke RtlZeroMemory, ADDR DsplVistaVerEdtn, 128
    MOV eax, OFFSET DsplVistaVerEdtn
    MOV lpVistaEdtn, eax
    invoke lstrcpy, ADDR DsplVistaVerEdtn, ADDR szWinSrvr2008Stnd

AddVstaEditn:    ;    There are a number of flag values that are not handled here.    
    .IF dwRtrnProdctTyp==PRODUCT_ULTIMATE   
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szUltimatEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_PROFESSIONAL
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szVstaProfesnl
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_HOME_PREMIUM
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szHomePremium
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_HOME_BASIC
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szHoneBasic
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrpriseEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_BUSINESS
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szBusinesEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_STARTER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szStartrEditn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_CLUSTER_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szClustrSrvrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_DATACENTER_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szDataCntrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_DATACENTER_SERVER_CORE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szDatCntrCoreEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrprseSrvrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE_SERVER_CORE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrprsCoreEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE_SERVER_IA64
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEntrprsItaniumEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_SMALLBUSINESS_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szSmalBusinsSrvr
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_SMALLBUSINESS_SERVER_PREMIUM
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szSmalBusnsSrvrPrem
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_STANDARD_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szStandrdEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_STANDARD_SERVER_CORE
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szStandrdCoreEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_WEB_SERVER
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szWebSrvrEdtn
    invoke lstrcat, ADDR DsplVistaVerEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSE    
    invoke lstrlen, ADDR DsplVistaVerEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplVistaVerEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ENDIF    

WinSeven:    ;    The server version of Windows Seven (Major = 6, Minor = 1), is Windows Server 2008 R2.     
;    Build the string that correctly describes the Windows Seven edition.    
    CMP LoclOperatSystem.wProductType, VER_NT_WORKSTATION
    JNZ SevnSrvr2008R2
    invoke RtlZeroMemory, ADDR DsplWinSevnEdtn, 128
    MOV eax, OFFSET DsplWinSevnEdtn
    MOV lpWinSevnEdtn, eax
    invoke lstrcpy, ADDR DsplWinSevnEdtn, ADDR szWinSevnWrkStn
    JMP AddSevenEditn

SevnSrvr2008R2:
    invoke RtlZeroMemory, ADDR DsplWinSevnEdtn, 128
    MOV eax, OFFSET DsplWinSevnEdtn
    MOV lpWinSevnEdtn, eax
    invoke lstrcpy, ADDR DsplWinSevnEdtn, ADDR szWinSevnSrvrR2

 AddSevenEditn:    ;    There are a number of flag values that are not handled here.    
    .IF dwRtrnProdctTyp==PRODUCT_ULTIMATE   
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szUltimatEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_PROFESSIONAL
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szVstaProfesnl
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_HOME_PREMIUM
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szHomePremium
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_HOME_BASIC
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szHoneBasic
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEntrpriseEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_BUSINESS
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szBusinesEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_STARTER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szStartrEditn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_CLUSTER_SERVER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szClustrSrvrEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_DATACENTER_SERVER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szDataCntrEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_DATACENTER_SERVER_CORE
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szDatCntrCoreEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE_SERVER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEntrprseSrvrEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE_SERVER_CORE
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEntrprsCoreEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_ENTERPRISE_SERVER_IA64
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEntrprsItaniumEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_SMALLBUSINESS_SERVER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szSmalBusinsSrvr
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_SMALLBUSINESS_SERVER_PREMIUM
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szSmalBusnsSrvrPrem
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_STANDARD_SERVER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szStandrdEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_STANDARD_SERVER_CORE
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szStandrdCoreEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSEIF dwRtrnProdctTyp==PRODUCT_WEB_SERVER
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szWebSrvrEdtn
    invoke lstrcat, ADDR DsplWinSevnEdtn, ADDR szEndLine   
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr
    .ELSE    
    invoke lstrlen, ADDR DsplWinSevnEdtn
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplWinSevnEdtn, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP BuildNumbr   
    .ENDIF    

BuildNumbr:    
    invoke RtlZeroMemory, ADDR DsplBuldNumbr, 128
    invoke RtlZeroMemory, ADDR OSBuildNum, 32
    MOV eax, LoclOperatSystem.dwBuildNumber
    invoke DwtoA, eax, ADDR OSBuildNum
    invoke lstrcpy, ADDR DsplBuldNumbr, ADDR szWinBldNum    
    invoke lstrcat, ADDR DsplBuldNumbr, ADDR OSBuildNum    
    invoke lstrcat, ADDR DsplBuldNumbr, ADDR szEndLine    
    invoke lstrlen, ADDR DsplBuldNumbr
    MOV dwLenWrtFile, eax    
    invoke WriteFile, hInfoFile, ADDR DsplBuldNumbr, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    CMP LoclOperatSystem.wServicePackMajor, 0
    JZ NoServcPack
    invoke RtlZeroMemory, ADDR DsplServcPacks, 128
    invoke RtlZeroMemory, ADDR ServicePack, 32
    MOVZX eax, LoclOperatSystem.wServicePackMajor
    invoke DwtoA, eax, ADDR ServicePack
    invoke lstrcpy, ADDR DsplServcPacks, ADDR szInstlSrvcPck    
    invoke lstrcat, ADDR DsplServcPacks, ADDR szMajSrvcPk    
    invoke lstrcat, ADDR DsplServcPacks, ADDR ServicePack
    invoke RtlZeroMemory, ADDR ServicePack, 32
    MOVZX eax, LoclOperatSystem.wServicePackMinor
    invoke DwtoA, eax, ADDR ServicePack
    invoke lstrcat, ADDR DsplServcPacks, ADDR szMinrSrvPk
    invoke lstrcat, ADDR DsplServcPacks, ADDR ServicePack
    invoke lstrcat, ADDR DsplServcPacks, ADDR szEndLine    
    invoke lstrlen, ADDR DsplServcPacks
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR DsplServcPacks, dwLenWrtFile, ADDR dwLenNumWrt, NULL
    JMP OSVerCorrct

NoServcPack:
    invoke lstrlen, ADDR szNoServicePack
    MOV dwLenWrtFile, eax
    invoke WriteFile, hInfoFile, ADDR szNoServicePack, dwLenWrtFile, ADDR dwLenNumWrt, NULL

OSVerCorrct:    
    invoke SetFilePointer, hInfoFile, 0, NULL, FILE_CURRENT
    MOV dwCurFilePtr, eax
    invoke CloseHandle, hInfoFile
    MOV eax, 0    
    MOV hInfoFile, eax
    MOV lpVerInfo, eax    

    RET
ChckOperSysVersion ENDP    

;***************************************************************************************************
;    The system calls the DLL Entry-Point function whenever 
;    processes and threads load or unload the DLL.
;    In the body of the Dynamic-Link Library Entry-Point Function,  
;    you may handle any combination of the following scenarios in  
;    which the DLL entry point has been called.     
;***************************************************************************************************
DllMain proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
;	.if reason==DLL_PROCESS_ATTACH    
;	.endif
	mov  eax, TRUE
            RET
DllMain ENDP  
;***************************************************************************************************
End DllMain
;***************************************************************************************************
